#include"defs.h"
#include"class.h"
USART::~USART()
{
	putS("Ich wurde geloescht\n\r");
}
USART::USART()
{
	RCC_APB2ENR|=(1<<USART1EN);
	GPIOA_CRH&=~((1<<MODE9_1)|(1<<MODE9_0)
			   |(1<<CNF9_1)|(1<<CNF9_0)				
			   |(1<<MODE10_1)|(1<<MODE10_1)
			   |(1<<CNF10_1)|(1<<CNF10_1));  								//PA10(RX)input floating
	GPIOA_CRH|=(1<<MODE9_1)|(1<<MODE9_0)|(1<<CNF9_1);						//PA9(TX) alternate output push-pull
  
  USART1_BRR=(1<<0)|(1<<4)|(1<<5)|(1<<6)|(1<<9);						//USART1_BRR=39,0625S
  USART1_CR1=(1<<UE)|(1<<TE)|(1<<RE);
}
void USART::putcH(unsigned char ch)
{
	while(!(USART1_SR &(1<<TXE)));
	USART1_DR=ch;
}

void USART::putS(char *string)
{
	while(*string)
	{	
		putcH((unsigned char)*string);
		string++;
	}
}

unsigned char USART::getcH()
{
	while(!(USART1_SR &(1<<RXNE)));
	return USART1_DR;
}