/* GPIO GENERAL*/
#define CNF10_1				11
#define CNF10_0				10
#define MODE10_1			9
#define MODE10_0			8

#define CNF9_1				7
#define CNF9_0				6		
#define MODE9_1				5	
#define MODE9_0				4
/*----------------------------------------------------------------------------*/

/* GPIO PORTA*/
#define GPIO_PORT_A 		0x40010800
#define GPIOA_CRL 			(*((volatile unsigned long*)(GPIO_PORT_A +0x00)))
#define GPIOA_CRH 			(*((volatile unsigned long*)(GPIO_PORT_A +0x4)))
#define GPIOA_BSRR  		(*((volatile unsigned long*)(GPIO_PORT_A +0x10)))

/* GPIO PORTB*/
#define GPIO_PORT_B 		0x40010C00
#define GPIOB_CRL 			(*((volatile unsigned long*)(GPIO_PORT_B +0x00)))
#define GPIOB_CRH 			(*((volatile unsigned long*)(GPIO_PORT_B +0x4)))
#define GPIOB_BSRR  		(*((volatile unsigned long*)(GPIO_PORT_B +0x10)))

/* CLOCK*/
#define RCC_APB2ENR  		(*((volatile unsigned long*)(0x40021000 +0x18)))
#define AFIOEN				0
#define IOPAEN				2
#define IOPBEN				3
#define USART1EN			14
	
/* USART1*/
#define USART1_ADDRESS		0x40013800
#define USART1_SR 			(*((volatile unsigned long*)(USART1_ADDRESS +0x00)))
#define USART1_DR			(*((volatile unsigned long*)(USART1_ADDRESS +0x04)))
#define USART1_BRR			(*((volatile unsigned long*)(USART1_ADDRESS +0x08)))
#define USART1_CR1			(*((volatile unsigned long*)(USART1_ADDRESS +0x0C)))
#define USART1_CR2			(*((volatile unsigned long*)(USART1_ADDRESS +0x10)))
#define USART1_CR3 			(*((volatile unsigned long*)(USART1_ADDRESS +0x14)))
#define USART1_GTPR 		(*((volatile unsigned long*)(USART1_ADDRESS +0x18)))
#define RXNE				5   //Read data register not empty
#define TXE					7	//Transmit data register empty
#define UE					13	//USART enable
#define TE					3	//Transmitter enable
#define RE					2   //Receiver enable
	
#define DELAYTIME			0x111111//0x11111111